<?php
/**
* SEF Advance extension for RD RSS
*
* This extension will give the SEF Advance style URLs to the RD_RSS component
* Place this file (sef_ext.php) in the main component directory
*
* Copyright (C) 2008 Emir Sakic, http://www.sakic.net, All rights reserved.
*
* Comments: for SEF Advance > v3.6
**/

class sef_rd_rss {

	/**
	* Creates the SEF Advance URL out of the request
	* Input: $string, string, The request URL (index.php?option=com_example&Itemid=$Itemid)
	* Output: $sefstring, string, SEF Advance URL ($var1/$var2/)
	**/
	function create ($string) {
		global $database;
		// $string == "index.php?option=com_rd_rss&Itemid=$Itemid&id=$id"
		$sefstring = '';
		if (eregi('&amp;id=',$string)) {
			$temp = explode('&amp;id=', $string);
			$temp = explode('&', $temp[1]);
			$id = $temp[0];
			$query = "SELECT `name` FROM #__rd_rss WHERE `id`='$id'";
			$database->setQuery( $query );
			$name = $database->loadResult();
			$sefstring .= sefencode($name).'/';
		}
		// $sefstring == "$name/"
		return $sefstring;
	}

	/**
	* Reverts to the query string out of the SEF Advance URL
	* Input:
	*    $url_array, array, The SEF Advance URL split in arrays
	*    $pos, int, The position offset for virtual directories (first virtual directory, which is the component name, begins at $pos+1)
	* Output: $QUERY_STRING, string, query string (var1=$var1&var2=$var2)
	*    Note that this will be added to already defined first part (option=com_example&Itemid=$Itemid)
	**/
	function revert ($url_array, $pos) {
		global $database;
		if (( ini_get('register_globals')==1 && (!defined('RG_EMULATION') || RG_EMULATION==1) ) ||
			( ini_get('register_globals')==0 && (defined('RG_EMULATION') && RG_EMULATION==1) ) ) {
			// if register globals on, emulation on OR register globals off, emulation on
			// then define all variables you pass as globals
			global $id;
		}
 		// Examine the SEF Advance URL and extract the variables building the query string
		$QUERY_STRING = '';
		if (isset($url_array[$pos+2]) && $url_array[$pos+2]!='') {
			// .../rd_rss/$id/
			$name = sefdecode($url_array[$pos+2]);
			$query = "SELECT `id` FROM #__rd_rss WHERE `name`='$name' AND published=1";
			$database->setQuery( $query );
			$id = $database->loadResult();
			$_GET['id'] = $_REQUEST['id'] = $id;
			$QUERY_STRING .= "&id=$id";
		}
		// $QUERY_STRING == "id=$id";
		return $QUERY_STRING;
	}

}
?>